include "Zeropage.inc"
include "Vram.inc"

Char_Space equ 0

pDestination equ ZW0
pSource equ ZW1


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        lda #low Vram | sta <pDestination
        lda #high Vram | sta <pDestination+1
        ldx #VramHeight+2
        do
            lda #Char_Space
            ldy #0
            do
                sta (<pDestination),y
                iny
                cpy #VramWidth
            while ne | wend

            lda <pDestination | clc | adc #low VramWidth | sta <pDestination
            lda <pDestination+1 | adc #high VramWidth | sta <pDestination+1
            dex
        while ne | wend
    pla
rts


; ptr<byte> VramAddress(byte x, byte y);
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_x:	defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_y:	defs 1
cseg
VramAddress_: public	VramAddress_
	pha
        lda	VramAddress_y
        asl a | asl a | asl a  ;*8
        sta <ZW0 | lda #0 | sta <ZW0+1
        asl <ZW0 | rol <ZW0+1 ;16
        asl <ZW0 | rol <ZW0+1 ;32
        lda VramAddress_x | clc | adc <ZW0 | sta <ZW0
        lda <ZW0+1 | adc #0 | sta <ZW0+1
        lda <ZW0 | clc|adc #low Vram | tay
        lda <ZW0+1 | adc #high Vram | tax
	pla
rts


; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:	defs 2
Put_@Param1: public Put_@Param1
Put_c:	defs 1
cseg
Put_: public Put_
    pha
        lda Put_@Param0 | sta <pDestination
        lda Put_@Param0+1 | sta <pDestination+1
        lda Put_c
        ldy #0
        sta (<pDestination),y
        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_pVram:	defs 2
PrintC_@Param1: public PrintC_@Param1
PrintC_c:	defs 1
cseg
CharTable:
    defb ' -0123456789ABCEFGHIMNOPRSTUV'
PrintC_: public PrintC_
    pha
        lda PrintC_@Param1
        ldx #0
        do
            cmp CharTable,x
            beq PrintC_exit
            inx
            cpx #29
        while ne | wend
        ldx #Char_Space
        PrintC_exit:        
        lda PrintC_@Param0 | sta <pDestination
        lda PrintC_@Param0+1 | sta <pDestination+1
        txa
        ora #$80
        ldy #0
        sta (<pDestination),y

        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts
